//
// Software License for AMDiS
//
// Copyright (c) 2010 Dresden University of Technology 
// All rights reserved.
// Authors: Simon Vey, Thomas Witkowski et al.
//
// This file is part of AMDiS
//
// See also license.opensource.txt in the distribution.


#include "DofComm.h"

namespace AMDiS {

  using namespace std;

  void DofComm::removeEmpty()
  {
    FUNCNAME("DofComm::removeEmpty()");

    for (unsigned int i = 0; i < data.size(); i++) {
      DataIter dit = data[i].begin();
      while (dit != data[i].end()) {
	FeMapIter it = dit->second.begin();
	while (it != dit->second.end()) {
	  if (it->second.size() == 0) {
	    const FiniteElemSpace *fe = it->first;
	    ++it;
	    dit->second.erase(fe);
	  } else
	    ++it;
	}
	
	if (dit->second.size() == 0)
	  data[i].erase(dit++);
	else
	  ++dit;
      }
    }
  }

  
  bool DofComm::Iterator::setNextFeMap()
  {
    FUNCNAME("DofComm::Iterator::setNextFeMap()");

    if (dataIter != dofComm.data[traverseLevel].end()) {
      TEST_EXIT_DBG(dataIter->second.size())("Should not happen!\n");

      feMapIter = dataIter->second.begin();
      
      if (traverseFeSpace != NULL) {
	if ((dataIter->second.count(traverseFeSpace) == 0))
	  return false;
	
	while (feMapIter->first != traverseFeSpace &&
	       feMapIter != dataIter->second.end())
	  ++feMapIter;
	
	TEST_EXIT_DBG(feMapIter != dataIter->second.end() &&
		      feMapIter->first == traverseFeSpace)
	  ("Should not happen!\n");
      }
      
      dofIter = feMapIter->second.begin();      
      dofCounter = 0;
    }

    return true;
  }

}
